jQuery(function($) {

	var myCREDScheduleModal = $( '#scedule-cron-modal' );
	var myCREDRunTaskModal  = $( '#run-task-modal' );
	var wWidth              = $(window).width();
	var dWidth              = wWidth * 0.75;

	$(document).ready(function(){

		if ( dWidth < 250 )
			dWidth = wWidth;

		if ( dWidth > 960 )
			dWidth = 960;

		/**
		 * Setup Schedule Modal
		 */
		myCREDScheduleModal.dialog({
			dialogClass : 'mycred-update-balance',
			draggable   : true,
			autoOpen    : false,
			title       : DebugBanking.title,
			closeText   : DebugBanking.close,
			modal       : true,
			width       : dWidth,
			height      : 'auto',
			resizable   : false,
			position    : { my: "center", at: "top+25%", of: window },
			show        : {
				effect     : 'fadeIn',
				duration   : 250
			},
			hide        : {
				effect     : 'fadeOut',
				duration   : 250
			}
		});

		/**
		 * Setup Run Task Modal
		 */
		myCREDRunTaskModal.dialog({
			dialogClass : 'mycred-update-balance',
			draggable   : true,
			autoOpen    : false,
			title       : DebugBanking.tasktitle,
			closeText   : DebugBanking.close,
			modal       : true,
			width       : dWidth,
			height      : 'auto',
			resizable   : false,
			position    : { my: "center", at: "top+25%", of: window },
			show        : {
				effect     : 'fadeIn',
				duration   : 250
			},
			hide        : {
				effect     : 'fadeOut',
				duration   : 250
			}
		});

		// Schedule
		$( '.schedule-cron-button' ).click(function(e){

			e.preventDefault();

			$( '#cron-schedule-field-action' ).val( $(this).data( 'action' ) );
			$( '#cron-schedule-field-service' ).val( $(this).data( 'service' ) );
			$( '#cron-schedule-field-item' ).val( $(this).data( 'item' ) );
			$( '#cron-schedule-field-point-type' ).val( $(this).data( 'type' ) );

			console.log( 'Click Schedule' );
			myCREDScheduleModal.dialog( 'open' );
			$( '#cron-schedule-form' ).submit();

		});

		// Schedule Form Submission
		$( '#cron-schedule-form' ).on( 'submit', function(e){

			e.preventDefault();

			var theform  = $(this);
			var loader   = $( '#form-submission-status-schedule' );

			theform.fadeOut(function(){

				loader.show();

				$.ajax({
					type       : "POST",
					data       : {
						action    : 'debug-mycred-bank-schedules',
						_nonce    : DebugBanking.schedule,
						form      : theform.serialize()
					},
					dataType   : "JSON",
					url        : DebugBanking.ajaxurl,
					beforeSend : function() {

						

					},
					success    : function( response ) {

						// Nonce expired
						if ( response.success === undefined ) {
							location.reload();
						}

						// Got some sort of result
						else {

							theform.empty().append( response.data );

							loader.hide();
							theform.show();

						}

					}
				});

			});

		});

		myCREDScheduleModal.on( "dialogclose", function( event, ui ) {

			$( '#cron-schedule-form' ).empty().append( DebugBanking.schedulefield );

		} );

		// Run Task
		$( '.run-task-button' ).click(function(e){

			e.preventDefault();

			$( '#run-task-field-action' ).val( $(this).data( 'action' ) );
			$( '#run-task-field-service' ).val( $(this).data( 'service' ) );
			$( '#run-task-field-item' ).val( $(this).data( 'item' ) );
			$( '#run-task-field-point-type' ).val( $(this).data( 'type' ) );

			console.log( 'Click Task' );
			myCREDRunTaskModal.dialog( 'open' );
			$( '#run-task-form' ).submit();

		});

		// Task Form Submission
		$( '#run-task-form' ).on( 'submit', function(e){

			e.preventDefault();

			var theform  = $(this);
			var loader   = $( '#form-submission-status-task' );

			theform.fadeOut(function(){

				loader.show();

				$.ajax({
					type       : "POST",
					data       : {
						action    : 'debug-mycred-bank-tasks',
						_nonce    : DebugBanking.task,
						form      : theform.serialize()
					},
					dataType   : "JSON",
					url        : DebugBanking.ajaxurl,
					beforeSend : function() {

						

					},
					success    : function( response ) {

						// Nonce expired
						if ( response.success === undefined ) {
							location.reload();
						}

						// Got some sort of result
						else {

							theform.empty().append( response.data );

							loader.hide();
							theform.show();

						}

					}
				});

			});

		});

		myCREDRunTaskModal.on( "dialogclose", function( event, ui ) {

			$( '#run-task-form' ).empty().append( DebugBanking.taskfields );

		} );

		$( '.mycred-container' ).on( 'click', '.slide-content', function(e){

			e.preventDefault();

			var toslideup   = $(this).data( 'up' );
			var toslidedown = $(this).data( 'down' );
			$( '#' + toslideup ).slideUp();
			$( '#' + toslidedown ).slideDown();

		});

		$( '.mycred-container' ).on( 'change', '.toggle-description', function(e){

			e.preventDefault();

			$( '.mycred-container .toggle-this' ).slideUp();

			var totoggle = $(this).find( ':selected' );
			$( '#' + totoggle.data( 'target' ) ).slideDown();

		});

	});

});